﻿Imports System.Drawing.Drawing2D

Module Module_FillBars

    ' =======================================================================================
    '  Display Data Scope
    ' =======================================================================================
    Friend Sub DisplayDataScope(ByVal pbox As PictureBox, _
                                ByVal count1 As Single, _
                                ByVal count2 As Single, _
                                ByVal speed As Int32)

        ' ------------------------------------------------ remove possible errors
        If count1 < -1000000 Then count1 = 0
        If count2 < -1000000 Then count2 = 0
        If count1 > 1000000 Then count1 = 0
        If count2 > 1000000 Then count2 = 0
        ' ------------------------------------------------ using a bitmap for best performance
        If pbox.Image Is Nothing Then
            InitPictureboxImage(pbox)
        End If
        ' ------------------------------------------------ using "Graphics.FromImage" for best performance
        Dim g As Graphics = Graphics.FromImage(pbox.Image)
        Dim px As Single = pbox.ClientSize.Width - 1
        '
        ' ------------------------------------------------ draw the scale
        Dim d As Single = pbox.ClientSize.Height / 10.1F
        Dim y As Single = 1
        Dim p1 As Pen = New Pen(Color.FromArgb(140, 140, 140))
        Dim p2 As Pen = New Pen(Color.FromArgb(210, 210, 210))
        For i As Int32 = 0 To 10
            g.DrawLine(p1, px, y, px + 1, y)
            y += d / 2
            g.DrawLine(p2, px, y, px + 1, y)
            y += d / 2
        Next
        ' ------------------------------------------------ draw indicators
        p1 = New Pen(Color.DarkBlue, 2)
        p2 = New Pen(Color.DarkRed, 2)
        Dim py1 As Single = 2.0F * count1 + pbox.ClientSize.Height / 2.0F '- d / 2
        Dim py2 As Single = 2.0F * count2 + pbox.ClientSize.Height / 2.0F '- d / 2
        Static oldy1 As Single = 1000000
        Static oldy2 As Single = 1000000
        If Single.IsNaN(oldy1) OrElse Math.Abs(oldy1 - py1) > 1000 Then oldy1 = py1
        If Single.IsNaN(oldy2) OrElse Math.Abs(oldy2 - py2) > 1000 Then oldy2 = py2
        g.DrawLine(p1, px - 1, oldy1, px, py1)
        g.DrawLine(p2, px - 1, oldy2, px, py2)
        oldy1 = py1
        oldy2 = py2
        ' ------------------------------------------------ scroll
        Static n As Int32 = 0
        n += speed
        If n > 100 Then
            n -= 100
            ' ---------------------------------------------------- original
            'ImageScrollInPlace(pbox.Image, -1, 0, 0)
            ' ---------------------------------------------------- fast
            g.CompositingQuality = CompositingQuality.HighSpeed
            g.SmoothingMode = SmoothingMode.HighSpeed
            g.InterpolationMode = InterpolationMode.Low
            'g.DrawImage(pbox.Image, -1, 0) '<-- NOT WORKING ON XP
            g.DrawImage(CType(pbox.Image.Clone, Image), -1, 0)
            g.DrawLine(Pens.AliceBlue, px, 0, px, pbox.ClientSize.Height)
            ' ---------------------------------------------------- 
            pbox.Invalidate()
        End If
    End Sub


    ' =======================================================================================
    '  FILL PICTURE BOX - WITH SINGLE COLOR
    ' =======================================================================================
    Friend Sub FillPictureBox(ByVal pbox As PictureBox, _
                              ByVal value As Double, _
                              ByVal c1 As Color, _
                              ByVal c2 As Color)
        ' ------------------------------------------------------- using a bitmap for best performance
        If pbox.Image Is Nothing Then
            InitPictureboxImage(pbox)
        End If
        ' -------------------------------------------------------
        If Double.IsNaN(value) Then value = 0
        If value < 0 Then value = 0
        If value > 1 Then value = 1
        Dim v As Int32 = CInt(value * pbox.ClientSize.Width)
        ' ------------------------------------------------------- using "Graphics.FromImage" for best performance
        Dim g As Graphics = Graphics.FromImage(pbox.Image)
        g.FillRectangle(New SolidBrush(c1), 0, 0, v, pbox.ClientSize.Height)
        g.FillRectangle(New SolidBrush(c2), v, 0, pbox.ClientSize.Width - v, pbox.ClientSize.Height)
        ' ------------------------------------------------------- final refresh - no flickering
        pbox.Invalidate()
    End Sub

    Friend Sub FillPictureBox_Horizontal(ByVal pbox As PictureBox, _
                                          ByVal value As Double, _
                                          ByVal c1 As Color, _
                                          ByVal c2 As Color)
        ' ------------------------------------------------------- using a bitmap for best performance
        If pbox.Image Is Nothing Then
            InitPictureboxImage(pbox)
        End If
        ' -------------------------------------------------------
        If Double.IsNaN(value) Then value = 0
        If value < 0 Then value = 0
        If value > 1 Then value = 1
        Dim v As Int32 = CInt(value * pbox.ClientSize.Width)
        ' ------------------------------------------------------- using "Graphics.FromImage" for best performance
        Dim g As Graphics = Graphics.FromImage(pbox.Image)
        g.FillRectangle(New SolidBrush(c1), 0, 0, v, pbox.ClientSize.Height)
        g.FillRectangle(New SolidBrush(c2), v, 0, pbox.ClientSize.Width - v, pbox.ClientSize.Height)
        '
        ' ------------------------------------------------------- final refresh - no flickering
        pbox.Refresh()
    End Sub

End Module
